clear;

typ_motprev='TG_N';        %typ motoru a prevodovky M=Maxon a planetova do 120 Nm
if strcmp(typ_motprev,'M')
    ka2=0.00011501;
    ka1=0.00429112;
    ka0=-0.00111210;
    kb1=0.06753971;
    kb0=0.05644954;
elseif strcmp(typ_motprev,'TG_M80')
    ka2=0.0000119966;
    ka1=-0.000179674;
    ka0=7.40213;
    kb1=0.00530837;
    kb0=-0.0422837;
elseif strcmp(typ_motprev,'TG_N')
    ka2=6.171372e-5;
    ka1=9.612251e-2;
    ka0=-3.506779;
    kb1=1.381432e-2;
    kb0=2.430787;
end;
%dlka ramen a mrn hmotnost
lc=2;                   %celkov dlka ramen
l0=0.15;                %podstavec - nult lnek
merna_hmotnost=2699;    %mrn hmotnost materilu ramen kg/m3

%objekt manipulace - koule
mOM=20;                  %hmotnost objektu manipulace - koule
merna_hmotnostOM=7850;  %mrn hmotnost materilu OM kg/m3 pro kontrolu v Creo
rOM=(3*mOM/(4*pi*merna_hmotnostOM))^(1/3);%pro kontrolu v Creo


t_max=3;              %as k dosaen 1m vky

sigma_max=50e+6;        %maximln napt v materilu ramen [Pa]

f4=[0;0;0];             %Technologick sla na konci
n4=[0;0;0];             %Technologicky moment na konci

pomer_sirka_vyska=0.8;
g=9.80665;
G=[0;0;-g];

format long;
i=0;                    %index pro prbhy - pomr ramen
delta_t=0.01;           %krok as pro cel pohyb ramen
pomer_min=0.1;          %minimln hodnota pomru ramen
pomer_max=2.0;          %maximln hodnota pomru ramen
pomer_krok=0.1;         %krok pro pomr ramen

%nastaven promnnch pro grafy
pocet=round((pomer_max-pomer_min)/pomer_krok+1);
prace=zeros(pocet,1);
pomer=zeros(pocet,1);
tau1max=zeros(pocet,1);
tau2max=zeros(pocet,1);
tau3max=zeros(pocet,1);
m_celk=zeros(pocet,1);
tl1max=zeros(pocet,1);
tl2max=zeros(pocet,1);
tl3max=zeros(pocet,1);
a3max=zeros(pocet,1);
m1max=zeros(pocet,1);
m2max=zeros(pocet,1);
m3max=zeros(pocet,1);
m1mpmax=zeros(pocet,1);
m2mpmax=zeros(pocet,1);
m3mpmax=zeros(pocet,1);
l1max=zeros(pocet,1);
l2max=zeros(pocet,1);
l3max=zeros(pocet,1);



pomer_prurez_delka=0.10;












for k=pomer_min:pomer_krok:pomer_max
    i=i+1
    pomer(i)=k;
    %Vpoet dlek ramen
    l1=lc/(k^2+k+1);
    l2=l1*k;
    l3=l2*k;

    tl_steny3=0.0001;       %zanm na 0,1 mm - tedy pli velk sigma
    tl_steny2=0.0001;       %zanm na 0,1 mm - tedy pli velk sigma
    tl_steny1=0.0001;       %zanm na 0,1 mm - tedy pli velk sigma
    
    H1=l1*pomer_prurez_delka;
    H2=l2*pomer_prurez_delka;
    H3=l3*pomer_prurez_delka;

    %Thov sly jsou vtinou vt ve smru z i pi velkch zrychlench
    %proto B me bt men ne H - vyzkouet vliv
    B1=H1*pomer_sirka_vyska;
    B2=H2*pomer_sirka_vyska;
    B3=H3*pomer_sirka_vyska;
    
    
    sigma3=sigma_max*10;    %nastavm poten sigma pro start cyklu
    sigma2=sigma_max*10;    %nastavm poten sigma pro start cyklu
    sigma1=sigma_max*10;    %nastavm poten sigma pro start cyklu
    
    
    % vypocet potebnho zrychlen ramen eps pro dosaen vky 1 m za dan as
    % t_max=2,1,0.1, atd. pro rzn pomry dlek
    
    eps=0;
    z=0;
    krok_eps=0.0001;

    while z<=1  %zvyuje zrychlen a peshne za as t vku 1m
        eps=eps+krok_eps;
    
        ddq1=eps;
        ddq2=eps;
        ddq3=eps;
    
        q1=ddq1*t_max^2/2;
        q2=ddq2*t_max^2/2;
        q3=ddq3*t_max^2/2;
    
        Ab0=[0 0 1 0;...
            1 0 0 l0;...
            0 1 0 0;...
            0 0 0 1];...
    
        A01=[cos(q1) -sin(q1) 0 l1*cos(q1); ...
             sin(q1)  cos(q1) 0 l1*sin(q1); ...
                 0        0   1        0; ...
                 0        0   0        1];

        A12=[cos(q2) -sin(q2) 0 l2*cos(q2); ...
             sin(q2)  cos(q2) 0 l2*sin(q2); ...
                 0        0   1        0; ...
                 0        0   0        1];
        
        A23=[cos(q3) -sin(q3) 0 l3*cos(q3); ...
             sin(q3)  cos(q3) 0 l3*sin(q3); ...
                 0        0   1        0; ...
                 0        0   0        1];
        
        Tb0 = Ab0;
        Tb1 = Ab0*A01;
        Tb2 = Ab0*A01*A12;
        Tb3 = Ab0*A01*A12*A23;

        z=Tb3(3,4);
    end;                    % v eps zstane posledn hodnota - tj. poadovan zrychlen
    
    eps_deg=180/pi*eps;     % zrychlen eps ve stupnch pro Creo

    ddq1=eps;
    ddq2=eps;
    ddq3=eps;
    
    Dr=[0 -1 0 0;...        %Diferenciln opertor
        1 0 0 0;...
        0 0 0 0;...
        0 0 0 0];
    
    
    %een pohybu ramen - kinematika, start t=0
    
    j=0; %index as
    
    for t_pohyb=0:delta_t:t_max
        j=j+1;
        
        q1=ddq1*t_pohyb^2/2;
        q2=ddq2*t_pohyb^2/2;
        q3=ddq3*t_pohyb^2/2;
    
        dq1=ddq1*t_pohyb;
        dq2=ddq2*t_pohyb;
        dq3=ddq3*t_pohyb;
    
        Ab0=[0 0 1 0;...
            1 0 0 l0;...
            0 1 0 0;...
            0 0 0 1];...
    
        A01=[cos(q1) -sin(q1) 0 l1*cos(q1); ...
             sin(q1)  cos(q1) 0 l1*sin(q1); ...
                 0        0   1        0; ...
                 0        0   0        1];

        A12=[cos(q2) -sin(q2) 0 l2*cos(q2); ...
             sin(q2)  cos(q2) 0 l2*sin(q2); ...
                 0        0   1        0; ...
                 0        0   0        1];
        
        A23=[cos(q3) -sin(q3) 0 l3*cos(q3); ...
             sin(q3)  cos(q3) 0 l3*sin(q3); ...
                 0        0   1        0; ...
                 0        0   0        1];
        
        Tb0 = Ab0;
        Tb1 = Ab0*A01;
        Tb2 = Ab0*A01*A12;
        Tb3 = Ab0*A01*A12*A23;
    
    
    
        k0=Tb0(1:3,3);
        k1=Tb1(1:3,3);
        k2=Tb2(1:3,3);
        k3=Tb3(1:3,3);
    
        Rb0=Tb0(1:3,1:3);
        Rb1=Tb1(1:3,1:3);
        Rb2=Tb2(1:3,1:3);
        Rb3=Tb3(1:3,1:3);
    
        omega0=[0;0;0];
        omega01=k0*dq1;
        omega12=k1*dq2;
        omega23=k2*dq3;
    
        omega1=omega0+omega01;
        omega2=omega1+omega12;
        omega3=omega2+omega23;
    
       
        p01=Rb0*A01(1:3,4);
        p12=Rb1*A12(1:3,4);
        p23=Rb2*A23(1:3,4);
    
        v0=[0;0;0];
        pom=Ab0*Dr*A01;
        v01=pom(1:3,4)*dq1;
        pom=Ab0*A01*Dr*A12;
        v12=pom(1:3,4)*dq2;
        pom=Ab0*A01*A12*Dr*A23;
        v23=pom(1:3,4)*dq3;
    
        v1=v0+v01+cross(omega0,p01);
        v2=v1+v12+cross(omega1,p12);
        v3=v2+v23+cross(omega2,p23);

        eps0=[0;0;0];
        eps01=k0*ddq1;
        eps12=k1*ddq2;
        eps23=k2*ddq3;
    
        eps1=eps0+eps01+cross(omega0,omega01);
        eps2=eps1+eps12+cross(omega1,omega12);
        eps3=eps2+eps23+cross(omega2,omega23);

        a0=[0;0;0];
        a01=cross(eps01,p01)+cross(omega01,cross(omega01,p01));
        a12=cross(eps12,p12)+cross(omega12,cross(omega12,p12));
        a23=cross(eps23,p23)+cross(omega23,cross(omega23,p23));

        a1=a0+a01+cross(eps0,p01)+2*cross(omega0,v01)+cross(omega0,cross(omega0,p01));
        a2=a1+a12+cross(eps1,p12)+2*cross(omega1,v12)+cross(omega1,cross(omega1,p12));
        a3=a2+a23+cross(eps2,p23)+2*cross(omega2,v23)+cross(omega2,cross(omega2,p23));
    
    
        %Vpoet prezu je proveden ve vchoz pozici ramen pi nejvtm
        %vyloen - njvtm zaten
        %Vpoet prezu zan od poslednho lnku a OM, zvyuji v cyklu
        %tlouku stny tak dlouho, a jsem na poadovanm sigma
    
        if t_pohyb==0   %Pot tlouku stny pro dan sigma jen v potenm ase t_pohyb=0 - je nejvt vyloen a nejv. sigma
        
            while sigma3>=sigma_max
            
                tl_steny3=tl_steny3+0.000001;

                
                Splochy_3=B3*H3-(B3-2*tl_steny3)*(H3-2*tl_steny3);
                m3=Splochy_3*l3*merna_hmotnost;

                pt11=[-l1/2;0;0];
                pt22=[-l2/2;0;0];
                xt33=(-l3/2*m3)/(mOM+m3);
                pt33=[xt33;0;0];

                pt1b=Rb1*pt11;
                pt2b=Rb2*pt22;
                pt3b=Rb3*pt33;

                at1=a1+cross(eps1,pt1b)+cross(omega1,cross(omega1,pt1b));
                at2=a2+cross(eps2,pt2b)+cross(omega2,cross(omega2,pt2b));
                at3=a3+cross(eps3,pt3b)+cross(omega3,cross(omega3,pt3b));
            
                %ohybov moment,kter je zatuje u kloubu lnek 3 - moment OM a
                %moment rameno do tit a m3 - zpsoben hmotnostmi a momentem setrvanosti ramene 3.

                J3tx=1/12*merna_hmotnost*H3*B3*l3*(H3^2+B3^2)-(1/12*merna_hmotnost*(H3-2*tl_steny3)*(B3-2*tl_steny3)*l3*((H3-2*tl_steny3)^2+(B3-2*tl_steny3)^2));
                J3ty=1/12*merna_hmotnost*H3*B3*l3*(B3^2+l3^2)-(1/12*merna_hmotnost*(H3-2*tl_steny3)*(B3-2*tl_steny3)*l3*((B3-2*tl_steny3)^2+l3^2));
                J3tz=1/12*merna_hmotnost*H3*B3*l3*(H3^2+l3^2)-(1/12*merna_hmotnost*(H3-2*tl_steny3)*(B3-2*tl_steny3)*l3*((H3-2*tl_steny3)^2+l3^2));
                J3t=[J3tx 0 0;
                    0 J3ty 0;
                    0 0 J3tz];
                %na 3. lnku je jet OM - moment setrvanosti koule OM  
                JOM=2/5*(mOM*rOM^2);
                %celk matice setr. 3. lnku - dut hranol vetn OM vzhledem k tit, orientace podle LCS3
                J3OMt=[J3tx+JOM                     0                               0;
                        0     J3ty+m3*(l3/2+xt33)^2+JOM+mOM*xt33^2              0;
                        0                       0                   J3tz+m3*(l3/2+xt33)^2+JOM+mOM*xt33^2];

                J3OM=Rb3*J3OMt*Rb3';
                f3=(m3+mOM)*(G-at3)+f4;
                N3sigma=-(J3OM*eps3+cross(omega3,J3OM*omega3));
                n3sigma=n4+N3sigma+cross(p23+pt3b,f3)-cross(pt3b,f4);

                %Kvadratic moment plochy

                Jplochy_3=1/12*(B3*H3^3-(B3-2*tl_steny3)*(H3-2*tl_steny3)^3);

                %nejvt napt
                sigma3=abs(n3sigma(1))/Jplochy_3*(H3/2);
            end;
            tl3max(i)=tl_steny3;
            
            %pidn kotoue o hmotnosti m3mp a momentu setrvanosti J3mp jako nhrady motoru a pevodovky
            %J3mp pidat k matici setrvanosti J3OMt a znovu vypotat potebn moment N3 a n3, m3mp pidat k hmotnosti
            %m2 na konci lnku 2, tedy nezatuje lnek 3 a nemus se pidvat tl_steny3

            J3mp=abs(n3sigma(1))^2*ka2+abs(n3sigma(1))*ka1+ka0;   %vzorec vpotu Jmp
            m3mp=abs(n3sigma(1))*kb1+kb0;                            %vzorec vpotu mmp
            delta3=1;
        
            while delta3>0.0001
                J3OMt=[J3tx+JOM                     0                           0;
                        0     J3ty+m3*(l3/2+xt33)^2+JOM+mOM*xt33^2              0;
                        0                           0                   J3tz+m3*(l3/2+xt33)^2+JOM+mOM*xt33^2+J3mp];

                J3OM=Rb3*J3OMt*Rb3';
                %nen tady nov vpoet f3, protoe hmotnost m3mp je zachycena na rameni 2 
                N3=-(J3OM*eps3+cross(omega3,J3OM*omega3));
                n3=n4+N3+cross(p23+pt3b,f3)-cross(pt3b,f4);
                tau3max(i)=k2'*-n3;
                delta3=tau3max(i)^2*ka2+tau3max(i)*ka1+ka0-J3mp;   %vzorec vpotu Jmp 
                J3mp=tau3max(i)^2*ka2+tau3max(i)*ka1+ka0;          %vzorec vpotu Jmp
                m3mp=tau3max(i)*kb1+kb0;                        %vzorec vpotu mmp
            end;
    
            %Vpoet rozmr nhradnch kotou pro simulaci hmotnosti a
            %momentu motor a pevod - rmp polomr, lmp dlka
            
            rmp3=sqrt(2*J3mp/m3mp);
            lmp3=m3mp^2/(2*merna_hmotnost*pi*J3mp);
            
            while sigma2>=sigma_max
            
                tl_steny2=tl_steny2+0.000001;

                
                Splochy_2=B2*H2-(B2-2*tl_steny2)*(H2-2*tl_steny2);
                m2=Splochy_2*l2*merna_hmotnost; %pozor musme ale pidat hmotnost m3mp

                pt11=[-l1/2;0;0];
                xt22=(-l2/2*m2)/(m3mp+m2);
                pt22=[xt22;0;0];
                xt33=(-l3/2*m3)/(mOM+m3);
                pt33=[xt33;0;0];

                pt1b=Rb1*pt11;
                pt2b=Rb2*pt22;
                pt3b=Rb3*pt33;

                at1=a1+cross(eps1,pt1b)+cross(omega1,cross(omega1,pt1b));
                at2=a2+cross(eps2,pt2b)+cross(omega2,cross(omega2,pt2b));
                at3=a3+cross(eps3,pt3b)+cross(omega3,cross(omega3,pt3b));

                %ohybov moment,kter je zatuje u kloubu lnek 2 
                %je vypotena tl_steny2 a tedy m2, tit 2. Pro dynamiku je nutno
                %stanovit J - moment setrvanosti sestavy 2 lnku
                %moment setrvanosti lnku J2t kolem tit kolem osy z vzhledem
                %k LCS2
                J2tx=1/12*merna_hmotnost*H2*B2*l2*(H2^2+B2^2)-(1/12*merna_hmotnost*(H2-2*tl_steny2)*(B2-2*tl_steny2)*l2*((H2-2*tl_steny2)^2+(B2-2*tl_steny2)^2));
                J2ty=1/12*merna_hmotnost*H2*B2*l2*(B2^2+l2^2)-(1/12*merna_hmotnost*(H2-2*tl_steny2)*(B2-2*tl_steny2)*l2*((B2-2*tl_steny2)^2+l2^2));
                J2tz=1/12*merna_hmotnost*H2*B2*l2*(H2^2+l2^2)-(1/12*merna_hmotnost*(H2-2*tl_steny2)*(B2-2*tl_steny2)*l2*((H2-2*tl_steny2)^2+l2^2));
                J2t=[J2tx 0 0;
                    0 J2ty 0;
                    0 0 J2tz];

                %na 2. lnku je jet motor a pevodovka, tedy m3mp, uvaujeme jen jeho hmotnost a posun tit, 
                %moment setrvanosti J3mp jsme zahrnuli do momentu setrvanosti
                %3. lnku, nen to ale asi pln pesn, zanedbvme setrvan
                %inky motoru a pevodovky 3 pi jejich oten

                %celk matice setr. 3. lnku - dut hranol vetn OM vzhledem k tit, orientace podle LCS3
                J2mp3t=[J2tx                     0                           0;
                        0     J2ty+m2*(l2/2+xt22)^2+m3mp*xt22^2              0;
                        0                       0                   J2tz+m2*(l2/2+xt22)^2+m3mp*xt22^2];

                J2mp3=Rb2*J2mp3t*Rb2';

                f2=(m2+m3mp)*(G-at2)+f3;
                N2sigma=-(J2mp3*eps2+cross(omega2,J2mp3*omega2));
                n2sigma=n3+N2sigma+cross(p12+pt2b,f2)-cross(pt2b,f3);
                %Kvadratic moment plochy

                Jplochy_2=1/12*(B2*H2^3-(B2-2*tl_steny2)*(H2-2*tl_steny2)^3);

                %nejvt napt
                sigma2=abs(n2sigma(1))/Jplochy_2*(H2/2);
            end;
            tl2max(i)=tl_steny2;
            
            %pidn kotoue o hmotnosti m2mp a momentu setrvanosti J2mp jako nhrady motoru a pevodovky
            %J2mp pidat k matici setrvanosti J2t a znovu vypotat potebn moment N2 a n2, m2mp pidat k hmotnosti
            %m1 na konci lnku 1

            J2mp=abs(n2sigma(1))^2*ka2+abs(n2sigma(1))*ka1+ka0;   %Tady bude skuten vzorec vpotu Jmp a mmp, asi rzn pro rzn druhy motor a pevodovek, rozliit na zatku pomoc volby
            m2mp=abs(n2sigma(1))*kb1+kb0;
            delta2=1;
        
            while delta2>0.0001
                J2mp3t=[J2tx                     0                           0;
                        0     J2ty+m2*(l2/2+xt22)^2+m3mp*xt22^2              0;
                        0                       0                   J2tz+m2*(l2/2+xt22)^2+m3mp*xt22^2+J2mp];

                J2mp3=Rb2*J2mp3t*Rb2';

                N2=-(J2mp3*eps2+cross(omega2,J2mp3*omega2));
                n2=n3+N2+cross(p12+pt2b,f2)-cross(pt2b,f3);
                tau2max(i)=k1'*-n2;
                delta2=tau2max(i)^2*ka2+tau2max(i)*ka1+ka0-J2mp;
                J2mp=tau2max(i)^2*ka2+tau2max(i)*ka1+ka0;
                m2mp=tau2max(i)*kb1+kb0;
            end;

            %Vpoet rozmr nhradnch kotou pro simulaci hmotnosti a
            %momentu motor a pevod - rmp polomr, lmp dlka
            
            rmp2=sqrt(2*J2mp/m2mp);
            lmp2=m2mp^2/(2*merna_hmotnost*pi*J2mp);
            
            while sigma1>=sigma_max

                tl_steny1=tl_steny1+0.000001;

                
                Splochy_1=B1*H1-(B1-2*tl_steny1)*(H1-2*tl_steny1);
                m1=Splochy_1*l1*merna_hmotnost; %pozor musme ale pidat hmotnost m3mp

                xt11=(-l1/2*m1)/(m2mp+m1);
                pt11=[xt11;0;0];
                xt22=(-l2/2*m2)/(m3mp+m2);
                pt22=[xt22;0;0];
                xt33=(-l3/2*m3)/(mOM+m3);
                pt33=[xt33;0;0];

                pt1b=Rb1*pt11;
                pt2b=Rb2*pt22;
                pt3b=Rb3*pt33;

                at1=a1+cross(eps1,pt1b)+cross(omega1,cross(omega1,pt1b));
                at2=a2+cross(eps2,pt2b)+cross(omega2,cross(omega2,pt2b));
                at3=a3+cross(eps3,pt3b)+cross(omega3,cross(omega3,pt3b));

                %ohybov moment,kter je zatuje u kloubu lnek 1 
                %je vypotena tl_steny1 a tedy m1, tit 1. Pro dynamiku je nutno
                %stanovit J - moment setrvanosti sestavy 1 lnku
                %moment setrvanosti lnku J1t kolem tit kolem osy z vzhledem
                %k LCS1
                J1tx=1/12*merna_hmotnost*H1*B1*l1*(H1^2+B1^2)-(1/12*merna_hmotnost*(H1-2*tl_steny1)*(B1-2*tl_steny1)*l1*((H1-2*tl_steny1)^2+(B1-2*tl_steny1)^2));
                J1ty=1/12*merna_hmotnost*H1*B1*l1*(B1^2+l1^2)-(1/12*merna_hmotnost*(H1-2*tl_steny1)*(B1-2*tl_steny1)*l1*((B1-2*tl_steny1)^2+l1^2));
                J1tz=1/12*merna_hmotnost*H1*B1*l1*(H1^2+l1^2)-(1/12*merna_hmotnost*(H1-2*tl_steny1)*(B1-2*tl_steny1)*l1*((H1-2*tl_steny1)^2+l1^2));
                J1t=[J1tx 0 0;
                    0 J1ty 0;
                    0 0 J1tz];

                %na 1. lnku je jet motor a pevodovka, tedy m2mp, uvaujeme jen jeho hmotnost a posun tit, 
                %moment setrvanosti J3mp jsme zahrnuli do momentu setrvanosti
                %2. lnku, nen to ale asi pln pesn, zanedbvme setrvan
                %inky motoru a pevodovky 2 pi jejich oten

                %celk matice setr. 1. lnku - dut hranol vetn motoru a
                %pevodovky vzhledem k tit, orientace podle LCS1
                J1mp2t=[J1tx                     0                           0;
                        0     J1ty+m1*(l1/2+xt11)^2+m2mp*xt11^2              0;
                        0                       0                   J1tz+m1*(l1/2+xt11)^2+m2mp*xt11^2];

                J1mp2=Rb1*J1mp2t*Rb1';

                f1=(m1+m2mp)*(G-at1)+f2;
                N1sigma=-(J1mp2*eps1+cross(omega1,J1mp2*omega1));
                n1sigma=n2+N1sigma+cross(p01+pt1b,f1)-cross(pt1b,f2);
                %Kvadratic moment plochy

                Jplochy_1=1/12*(B1*H1^3-(B1-2*tl_steny1)*(H1-2*tl_steny1)^3);

                %nejvt napt
                sigma1=abs(n1sigma(1))/Jplochy_1*(H1/2);
            end;
            tl1max(i)=tl_steny1;
            
            %pidn kotoue o hmotnosti m1mp a momentu setrvanosti J1mp jako nhrady motoru a pevodovky
            %J1mp pidat k matici setrvanosti J1t a znovu vypotat potebn moment N1 a n1, m1mp pidat k hmotnosti
            %m0 na konci podstavce

            J1mp=abs(n1sigma(1))^2*ka2+abs(n1sigma(1))*ka1+ka0;   %Tady bude skuten vzorec vpotu Jmp a mmp, asi rzn pro rzn druhy motor a pevodovek, rozliit na zatku pomoc volby
            m1mp=abs(n1sigma(1))*kb1+kb0;
            delta1=1;
        
            while delta1>0.0001
                J1mp2t=[J1tx                     0                           0;
                        0     J1ty+m1*(l1/2+xt11)^2+m2mp*xt11^2              0;
                        0                       0                   J1tz+m1*(l1/2+xt11)^2+m2mp*xt11^2+J1mp];

                J1mp2=Rb1*J1mp2t*Rb1';

                N1=-(J1mp2*eps1+cross(omega1,J1mp2*omega1));
                n1=n2+N1+cross(p01+pt1b,f1)-cross(pt1b,f2);
                tau1max(i)=k0'*-n1;
                delta1=tau1max(i)^2*ka2+tau1max(i)*ka1+ka0-J1mp;
                J1mp=tau1max(i)^2*ka2+tau1max(i)*ka1+ka0;
                m1mp=tau1max(i)*kb1+kb0;
            end;
            
            %Vpoet rozmr nhradnch kotou pro simulaci hmotnosti a
            %momentu motor a pevod - rmp polomr, lmp dlka
            
            rmp1=sqrt(2*J1mp/m1mp);
            lmp1=m1mp^2/(2*merna_hmotnost*pi*J1mp);
            
            a3max(i)=sqrt(a3(1)^2+a3(2)^2+a3(3)^2);
        end;    %konec vpotu tloutk stn pro dan sigma a nhradnch kotou motor a pevodovek v ase t=0, me zat pohyb
        
        %Vpoet kinematickch a dynamickch veliin bhem pohybu, vechny
        %hmotnosti lnk a nhradnch kotou pohon jsou ji znmy
        xt11=(-l1/2*m1)/(m2mp+m1);
        pt11=[xt11;0;0];
        xt22=(-l2/2*m2)/(m3mp+m2);
        pt22=[xt22;0;0];
        xt33=(-l3/2*m3)/(mOM+m3);
        pt33=[xt33;0;0];

        pt1b=Rb1*pt11;
        pt2b=Rb2*pt22;
        pt3b=Rb3*pt33;

        vt1=v1+cross(omega1,pt1b);
        vt2=v2+cross(omega2,pt2b);
        vt3=v3+cross(omega3,pt3b);
        
        vt1mag=sqrt(vt1(1)^2+vt1(2)^2+vt1(3)^2);
        vt2mag=sqrt(vt2(1)^2+vt2(2)^2+vt2(3)^2);
        vt3mag=sqrt(vt3(1)^2+vt3(2)^2+vt3(3)^2);
        
        at1=a1+cross(eps1,pt1b)+cross(omega1,cross(omega1,pt1b));
        at2=a2+cross(eps2,pt2b)+cross(omega2,cross(omega2,pt2b));
        at3=a3+cross(eps3,pt3b)+cross(omega3,cross(omega3,pt3b));

        f3=(m3+mOM)*(G-at3)+f4;
        J3OM=Rb3*J3OMt*Rb3';
        N3=-(J3OM*eps3+cross(omega3,J3OM*omega3));
        n3=n4+N3+cross(p23+pt3b,f3)-cross(pt3b,f4);
        tau3=k2'*-n3;
        f2=(m2+m3mp)*(G-at2)+f3;
        J2mp3=Rb2*J2mp3t*Rb2';
        N2=-(J2mp3*eps2+cross(omega2,J2mp3*omega2));
        n2=n3+N2+cross(p12+pt2b,f2)-cross(pt2b,f3);
        tau2=k1'*-n2;
        f1=(m1+m2mp)*(G-at1)+f2;
        J1mp2=Rb1*J1mp2t*Rb1';
        N1=-(J1mp2*eps1+cross(omega1,J1mp2*omega1));
        n1=n2+N1+cross(p01+pt1b,f1)-cross(pt1b,f2);
        tau1=k0'*-n1;
        
        m_celk(i)=m1mp+m1+m2mp+m2+m3mp+m3;
        m1max(i)=m1;
        m2max(i)=m2;
        m3max(i)=m3;
        m1mpmax(i)=m1mp;
        m2mpmax(i)=m2mp;
        m3mpmax(i)=m3mp;
        l1max(i)=l1;
        l2max(i)=l2;
        l3max(i)=l3;
        
    end;  %konec pohybu, me zat jin pomr ramen
    
    pot_energie1=(m1+m2mp)*g*(Tb1(3,4)+pt1b(3)); %plus je proto, e tit je zporn
    pot_energie2=(m2+m3mp)*g*(Tb2(3,4)+pt2b(3));
    pot_energie3=(m3+mOM)*g*(Tb3(3,4)+pt3b(3));
    
    kin_energie1=1/2*omega1(1)^2*J1mp2(1,1)+1/2*vt1mag^2*(m1+m2mp);% je spatne, mus tam bt i translan kin. energie
    kin_energie2=1/2*omega2(1)^2*J2mp3(1,1)+1/2*vt2mag^2*(m2+m3mp);
    kin_energie3=1/2*omega3(1)^2*J3OM(1,1)+1/2*vt3mag^2*(m3+mOM);
    prace(i)=pot_energie1+pot_energie2+pot_energie3+kin_energie1+kin_energie2+kin_energie3;
    a3mean=mean(a3max);
    if m1<=0 || m2<=0 || m3<=0 
        prace(i)=0;
        m_celk(i)=0;
        tau1max(i)=0;
        tau2max(i)=0;
        tau3max(i)=0;
        tl1max(i)=0;
        tl2max(i)=0;
        tl3max(i)=0;
    end;
end;
scrsz = get(0,'ScreenSize');
h=figure('Name','Vka profilu H mrn dlce ramene','Position',[scrsz(3)/10 scrsz(4)/10 scrsz(3)/2 scrsz(4)]);
subplot(3,2,1), plotyy(pomer,prace,pomer,m_celk);grid on;
hleg1 = legend('Prce','celkov hmotnost manipultoru');
title(['Prce [J] a celk. hmotnost ramen bez OM=',num2str(mOM),'[kg]']);
subplot(3,2,2), plot(pomer, tau1max,pomer, tau2max,pomer, tau3max);grid on;
hleg2 = legend('tau1','tau2','tau3');
title(['Max. momenty pohon [Nm] pro zrychlen a3=',num2str(a3mean),'[m/s2]']);
subplot(3,2,3), plot(pomer, tl1max,pomer, tl2max,pomer, tl3max);grid(gca,'minor');
hleg3 = legend('tl1','tl2','tl3');
title(['Tlouka stny pro H [m] mrn dlce, H=',num2str(pomer_prurez_delka),'*l']);
subplot(3,2,4), plot(pomer,l1max,pomer,l2max,pomer,l3max);grid on;
hleg4 = legend('l1','l2','l3');
title(['Dlka ramen [m]']);
subplot(3,2,5), plot(pomer, m1max,pomer,m2max,pomer,m3max);grid on;
hleg5 = legend('m1','m2','m3');
title(['Hmotnost ramen [kg]']);
subplot(3,2,6), plot(pomer, m1mpmax,pomer,m2mpmax,pomer,m3mpmax);grid on;
hleg6 = legend('m1mp','m2mp','m3mp');
title(['Hmotnost sestavy motor pevod [kg]']);